function mask = blobDetectScore(scorefile,calcScore,thresh)
% blobDetectScore find blobs that are cells on a score file and returns
% mask

    conElem=getconnectedelem(scorefile,thresh);
    mask=calcblobmask(conElem,thresh,calcScore);
    
end
function mask = calcblobmask(conElem,thresh,blobDetect)

    mask=inf([size(conElem,1) size(conElem,2)]);
    for j=1:size(conElem,3),

        prop=regionprops(conElem(:,:,j),'Area',...
            'EulerNumber','Extent','Eccentricity','Solidity');


        threshold=thresh(j);

        conn=conElem(:,:,j);
      
     
        for k=1:max(conn(:)),
           % imagesc(conn>0);
         %   title(['Frame: ' num2str(j)]);
        %    drawnow;
            label=blobDetect([threshold,prop(k).Area,prop(k).EulerNumber,...
                prop(k).Extent,prop(k).Eccentricity,prop(k).Solidity],...
                [1 1 1 1 1 1 1 1 1 1 1 1]);
            
            connadd=label*single(conn==k);
            connadd(connadd==0)=inf;
            mask=min(mask,connadd);
          
        end

    end
end
