function [ scanCoords s] = makemasks( imagename )

try
    curfig=gcf;
    h=waitbar(1,'Scoring image...');
    [s]=detectCell(imagename);

    figure
    imagesc(s);
    colorbar
    drawnow
    figure(curfig);
    
    temp=input('At what level do you wish to threshold the blob score: ','s');
    maskthreshold=str2double(temp);
    
    waitbar(0.6,h,'Filtering image...');
    s=medfilt2(s);
    Coords=struct('scanShape',[],'startPoint',[],'endPoint',[],'nLines',[],'orientation',[],'name',[]);
    waitbar(0.7,h,'Labeling image...');
    
    BW=bwlabel((s<maskthreshold)',8)';

    num_items=max(BW(:));
  
    curitem=1;
	
	%temp=input('How many lines do you wish to scan for every pixel (suggested range 0 to 1): ','s');
    %linesperpixel=str2double(temp);
	
	
    waitbar(0.8,h,'Finding lines...');
    for j=1:num_items,
        item_mask=(BW==j);
        item_size=sum(item_mask(:));
        
        [indy indx] = find(item_mask==1);
        itemname=['ROI-' num2str(curitem)];
        scanCoords(curitem).scanShape = 'line';
        scanCoords(curitem).startPoint=[min(indx) min(indy)];
        scanCoords(curitem).endPoint=[max(indx) max(indy)];
        if sum(scanCoords(curitem).startPoint-scanCoords(curitem).endPoint)==0,
            continue;
        end
        scanCoords(curitem).nLines=1;%ceil(linesperpixel*(max(indy)-min(indy)));
         scanCoords(curitem).orientation=1;
        scanCoords(curitem).name=itemname;
       



         curitem=curitem+1;
    end
    scanCoords=scanCoords(1:curitem-1);
    waitbar(1,h,'Done...');
    close(h);
catch 
	e=lasterror();
   close(h);
   rethrow(e); 
end