function [ temp ] = adaptnorm( im,wsize )
%ADAPTNORM takes an image and does inside frame gain control
%on window sizes wsize
    temp=im;
    s=size(im);
    temp2=ones(s(1)+2*wsize,s(2)+2*wsize)*mean(temp(:));
    temp2((wsize+1):(wsize+s(1)),(wsize+1):(wsize+s(2)))=temp;
    for x=(wsize+1):(wsize+s(1)),
        for y=(wsize+1):(wsize+s(2)),
           startx=x-ceil(wsize/2);
           endx=startx+wsize;
           starty=y-ceil(wsize/2);
           endy=starty+wsize;
           midx=ceil((endx-startx)/2);
           midy=ceil((endy-starty)/2);
           block=single(temp2(startx:endx,starty:endy));
           block=(block-mean(block(:)))/std(block(:));
           temp(x-wsize,y-wsize)=block(midx,midy);
        end
    end
    