%java -Xmx500M jboost.controller.Controller -b LogLossBoost -numRounds 300
%-S ./jboost/test -n test.spec -t test.data -T test.data -m calcScore.m
function [hRes] = calculateFeatures(stackName,trainingSet,calcIm,doappend)

if calcIm,
    hRes=generateImages(stackName,stackName(1:(end-4)));
    if ~hRes,
        error('Could not generate images');
    end
end

iminf=imfinfo(stackName);
% all of the filters that we used
ims=zeros(iminf(1).Height,iminf(1).Width,8,'uint16');

basename=stackName(1:(end-4));

ims(:,:,1)=medfilt2(imread([basename '.mean.tif']),[5 5]);
ims(:,:,2)=medfilt2(imread([basename '.var.tif']),[5 5]);
ims(:,:,3)=medfilt2(imread([basename '.cov.tif']),[5 5]);
ims(:,:,4)=medfilt2(imread([basename '.corr.tif']),[5 5]);
ims(:,:,5)=medfilt2(imread([basename '.mean.anorm.tif']),[5 5]);
ims(:,:,6)=medfilt2(imread([basename '.var.anorm.tif']),[5 5]);
ims(:,:,7)=medfilt2(imread([basename '.cov.anorm.tif']),[5 5]);
ims(:,:,8)=medfilt2(imread([basename '.corr.anorm.tif']),[5 5]);

numfeatures=size(ims,3);
numexamples=size(trainingSet,1);

disp('Starting first loop');
if doappend
    fd=fopen('test.data','a');
else
    fd=fopen('test.data','w');
end
for j=1:numexamples

    for k=1:numfeatures,
        point=ims(trainingSet(j,1),trainingSet(j,2),k);
        fprintf(fd,'%d,',point);
    end
    fprintf(fd,'%d,%d;\n',trainingSet(j,3),trainingSet(j,4));

end
fclose(fd);
specFile=['exampleTerminator=;\nattributeTerminator=,\nmaxBadExa=0\n'...
    'mean number\nvar number\ncov number\ncorr number\n'...
    'mean.anorm number\nvar.anorm number\ncov.anorm number\n' ....
    'corr.anorm number\nweight number'...
    '\nlabels (1,-1)'];

fs=fopen('test.spec','w');

fprintf(fs,specFile);

fclose(fs);

    
