function [ corrimageX corrimageY covimageX covimageY varimage] = ...
    makestatimage( varargin)
%corrimageX corrimageY covimageX covimageY varimage
%makestatimage takes a stack of images from 3D matrix or folder_in of 
%file type file_type and generates 3 basic filters

    if length(varargin)==2,
        im=varargin{1};
    elseif length(varargin)==3,
        im=loadimage(varargin{1},varargin{2});
    else
        error('Expecting input either makeaverageimg(im) or makeaverageimg(folder,filetype');
    end


    %wsize=varargin{end};
    disp('Variable window size is not implemented... window size is 6');
    s=size(im);
    if s(3)>200,
        im=im(:,:,1:200);
        s(3)=200;
    end
    
    %  Convolve very quickly 
    [ blockim] = double(makestatimage_opt(uint16(im)));
    
    %initialize output
    corrimageX=zeros(s(1:2));
    corrimageY=zeros(s(1:2));
    covimageX=zeros(s(1:2));
    covimageY=zeros(s(1:2));
    varimage=zeros(s(1:2));
    
    %make calculations
    for j=1:(s(1)-1),
        for k=1:(s(2)-1),
            
            temp=cov(squeezetoone(blockim(j,k,:)),...
                        squeezetoone(blockim(j,k+1,:)));
            temp2=cov(squeezetoone(blockim(j,k,:)),...
                        squeezetoone(blockim(j+1,k,:)));
            
            corrimageX(j,k)=temp(2,1)/sqrt(temp(1,1)*temp(2,2));
            covimageX(j,k)=temp(2,1);
            
            corrimageY(j,k)=temp2(2,1)/sqrt(temp2(1,1)*temp2(2,2));
            covimageY(j,k)=temp2(2,1);
            
            varimage(j,k)=sqrt(temp(1,1));

        end
    end
    
    %there are some padding errors which cause 0 values
    corrimageX(corrimageX==0)=mean(corrimageX(:));
    corrimageY(corrimageY==0)=mean(corrimageY(:));
    covimageX(corrimageX==0)=mean(covimageX(:));
    covimageY(corrimageX==0)=mean(covimageY(:));
    varimage(varimage==0)=mean(varimage(:));
    
end