//define the FILTER class

#include "prefilter.h"

void FILTER::FILTER(unsigned short *inputIm,mwSize *inSize,mwSize *convSize){
	//we haven't quite calculated yet
	meanCalc=false;
	varcovCalc=false;
	corrCalc=false;
	imSize=inSize;
	rawIm=inputIm;
	//convolve like crazy!!! (we dfine convIm now)
	convolve(convSize);
}

void FILTER::~FILTER(){
	//remove privates, we don't remove raw data since we didn't make it
	mxFree(convIm);
	mxFree(meanIm);
	mxFree(variIm);
	mxFree(covaImX);
	mxFree(covaImY);
	mxFree(corrImX);
	mxFree(corrImY);

	//eh...
	rawIm=NULL;
	meanCalc=false;
	varcovCalc=false;
	corrCalc=false;
}

double* FILTER::convolve(convSize){
	
    //calculate the actual normalization   
            
    int curP=0;
    double pixelValPrim = 0; //primitive pixel value
    double pixelVal = 0; //processed pixel value
    
    double padMean=0;
  
	convIm=(double*)mxCalloc(imSize[2]*imSize[1]*imSize[0],sizeof(double));

    //fill in the meanHold table
   
        
    for (int k=0; k<imSize[1]; k++){
         for (int j=0; j<imSize[0]; j++){        
            for (int i=0; i<imSize[2]; i++){

                //find space averaged time value
                pixelVal = 0;
                for (int a=-convSize[0]/2; a<convSize[0]/2; a++){
                    for (int b=-convSize[1]/2; b<convSize[1]/2; b++){
                        // point corresponding to pixel (a,b) in window
                        // on image imIn around (j,k) at time i
                        
                        curP=(j+a)+((k+b)*imSize[0])
                                    +(i*imSize[0]*imSize[1]);
                        
                        pixelValPrim = padMean;
                        if (curP>-1 && ((j+a)+((k+b)*imSize[0]))<
                                    (imSize[0]*imSize[1]-1)) {
                                pixelValPrim=double(rawIm[curP]);
                                
                          
                        }
                        pixelVal+=pixelValPrim;
                    }//for (int b=-winSize[1]/2; b<winSize[1]/2; b++)
                }//for (int a=-winSize[0]/2; a<winSize[0]/2; a++)
                
                
                curP=(j)+((k)*imSize[0])
                                    +(i*imSize[0]*imSize[1]);
              
                convIm[curP]=pixelVal/double(convSize[0]*convSize[1]);
                
                
                
            } //for (int i=0; i<inSize[2]; i++)      
        } //for (int k=0; k<inSize[1]; k++)
    } //for (int j=0; j<inSize[0]; j++)
}

double* FILTER::getMean(){
	//return mean value
	if (~meanCalc)
		calcMean();
	return meanIm;
	
}
double* FILTER::getVar(){
	//return mean value
	if (~varcovCalc)
		calcVarCov();
	return varIm;
}

double* FILTER::getCov(){
	//return mean value
	if (~varcovCalc)
		calcVarCov();
	return rms(covaImX,covaImY);
}

double* FILTER::getCorr(){
	//return mean value
	if (~corrCalc)
		calcCorr();
	return rms(corrImX,corrImY);
}

bool FILTER::calcMean(){

	meanIm=
	meanCalc=true;
	return meanCalc;
}

bool FILTER::calcVarCov(){
	varcovCalc=true;
	return varcovCalc;
}
bool FILTER::calcCorr(){
	if (~varcovCalc)
		calcVarCov();
	corrCalc=true;
	return corrCalc;

}