#pragma once

//Standard libs
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//mex lib
#include "mex.h"

//class

class FILTER{
public:

	//get data, calculate convolution
	FILTER(unsigned short *inputIm,mwSize *inSize,mwSize *convSize);

	//get data, if not yet calculated, calculate it
	double* getMean();
	double* getVar();
	double* getCov();
	double* getCorr();

	//kill and destroy
	~FILTER();

private:

	//data on which things are operated
	//should be handled at constructor
	unsigned short *rawIm,*convIm;
	mwSize *imSize;

	//the actual filters
	double *meanIm,*variIm,*covaImX,*covaImY,*corrImX,*corrImY;

	//was the filter already calculated?
	bool meanCalc, varcovCalc, corrCalc;

	//calculates the filters
	bool calcMean();
	bool calcVarCov();
	bool calcCorr();

	//called by constructor
	convolve(double *);

	//calc rms, as needed by getCov and getCorr
	double *rms(double*,double*);
};