function [ scores ims meanim] = scoreIm( stackName,scoreFunc,calcIm )
savePath='./temp_ims/';

pathElements=explode(stackName,'\/');
filename=pathElements{end};
basename=[savePath filename];
basename=basename(1:(end-4));


if calcIm,
    hRes=generateImages(stackName,basename);
    if ~hRes,
        error('Could not generate images');
    end
end

% all of the filters that we used
iminf=imfinfo([basename '.mean.tif'],'tif');
ims=zeros(iminf(1).Height,iminf(1).Width,8,'uint16');


ims(:,:,1)=medfilt2(imread([basename '.mean.tif']),[5 5]);
meanim=imread([basename '.mean.tif']);
ims(:,:,2)=medfilt2(imread([basename '.var.tif']),[5 5]);
ims(:,:,3)=medfilt2(imread([basename '.cov.tif']),[5 5]);
ims(:,:,4)=medfilt2(imread([basename '.corr.tif']),[5 5]);
ims(:,:,5)=medfilt2(imread([basename '.mean.anorm.tif']),[5 5]);
ims(:,:,6)=medfilt2(imread([basename '.var.anorm.tif']),[5 5]);
ims(:,:,7)=medfilt2(imread([basename '.cov.anorm.tif']),[5 5]);
ims(:,:,8)=medfilt2(imread([basename '.corr.anorm.tif']),[5 5]);

scores=zeros(iminf(1).Height,iminf(1).Width,'single');


ims=single(ims);

for j=1:iminf(1).Height,
    for k=1:iminf(1).Width,
        scores(j,k)=scoreFunc(ims(j,k,:),[1 1 1 1 1 1 1 1]);
    end
end
