function  updateView( handles )
%UPDATEVIEW draw the pretty picture (updates 3 screens and the text)

axes(handles.meanImage);
imagesc(handles.objData.meanIm);
colormap gray
curmask=handles.objData.objSeg==handles.objData.objNum;
curoutline=imdilate(curmask,ones(3))-curmask;

clabel=handles.objData.boosterData{handles.objData.threshNum}(handles.objData.objNum);


switch clabel,
    case 1,
        curoutlineRGB=zeros([size(curoutline) 3]);
        curoutlineRGB(:,:,2)=curoutline;
    case -1,
        curoutlineRGB=zeros([size(curoutline) 3]);
        curoutlineRGB(:,:,1)=curoutline;
    otherwise,       
        curoutlineRGB=single(repmat(curoutline,[1 1 3]));             
end

hold on
imagesc(curoutlineRGB,'AlphaData',single(curoutline));
colormap gray;
hold off

axes(handles.normmeanImage);
imagesc(handles.objData.normmeanIm);

axes(handles.choiceMap);
imagesc(handles.objData.choiceMap);

%texts
set(handles.cobj,'String',['Cur object: ' num2str(handles.objData.objNum)]);
set(handles.tobj,'String',['Total objects: ' num2str(handles.objData.objTot)]);
set(handles.clevel,'String',['Cur level: ' num2str(handles.objData.threshNum)]);
set(handles.tlevel,'String',['Total levels: ' num2str(length(handles.objData.threshList))]);
drawnow;