function [ corrimageX corrimageY covimageX covimageY varimage] = ...
    makestatimage( varargin)
%CORRELATIONIMAGE takes a stack of images from 3D matrix or folder_in of 
%file type file_type and generates an image based on correlation of pixels 
%in window wsize over time

if length(varargin)==2,
    im=varargin{1};
elseif length(varargin)==3,
    im=loadimage(varargin{1},varargin{2});
else
    error('Expecting input either makeaverageimg(im) or makeaverageimg(folder,filetype');
end

im=im(:,:,1:100);
wsize=varargin{end};

s=size(im);

corrimageX=zeros(s(1:2));
covimageX=zeros(s(1:2));
varimage=zeros(s(1:2));

for j=1:(s(1)-2*wsize+1),
    for k=1:(s(2)-wsize+1),
        block1=squeeze(sum(sum(im(j:(j+wsize-1),k:(k+wsize-1),:),1),2));
        block2=squeeze(sum(sum(im((j+wsize):(j+wsize*2-1),k:(k+wsize-1),:),1),2));
        temp=cov([block1 block2]);
        corrimageX(j,k)=temp(2,1)/sqrt(temp(1,1)*temp(2,2));
        covimageX(j,k)=temp(2,1);
        varimage(j,k)=sqrt(temp(1,1));
  
    end
end

%reposition
if wsize>1,
    temp=zeros(size(corrimageX));
    start1=wsize;
    finish1=s(1)-wsize;
    start2=ceil(wsize/2);
    finish2=s(2)-ceil(wsize/2);
    temp(start1:finish1,start2:finish2)= ...
    corrimageX(1:(finish1-start1+1),1:(finish2-start2+1));
    corrimageX=temp;
    
    temp=zeros(size(covimageX));
    temp(start1:finish1,start2:finish2)= ...
    covimageX(1:(finish1-start1+1),1:(finish2-start2+1));
    covimageX=temp;
    
    temp=zeros(size(varimage));
    start1=ceil(wsize/2);
    finish1=s(1)-ceil(wsize/2);
    start2=ceil(wsize/2);
    finish2=s(2)-ceil(wsize/2);
    temp(start1:finish1,start2:finish2)= ...
        varimage(1:(finish1-start1+1),1:(finish2-start2+1));
    varimage=temp;
end

corrimageY=zeros(s(1:2));
covimageY=zeros(s(1:2));
for j=1:(s(2)-2*wsize+1),
    for k=1:(s(1)-wsize+1),
        block1=squeeze(sum(sum(im(k:(k+wsize-1),j:(j+wsize-1),:),2),1));
        block2=squeeze(sum(sum(im(k:(k+wsize-1),(j+wsize):(j+wsize*2-1),:),2),1));
        temp=cov([block1 block2]);
        corrimageY(k,j)=temp(2,1)/sqrt(temp(1,1)*temp(2,2));
        covimageY(k,j)=temp(2,1);
    end
end

if wsize>1,
    temp=zeros(size(corrimageY));
    start1=ceil(wsize/2);
    finish1=s(1)-ceil(wsize/2);
    start2=wsize;
    finish2=s(2)-wsize;
    temp(start1:finish1,start2:finish2)= ...
    corrimageY(1:(finish1-start1+1),1:(finish2-start2+1));
    corrimageY=temp;
    
    temp=zeros(size(covimageY));
    temp(start1:finish1,start2:finish2)= ...
    covimageY(1:(finish1-start1+1),1:(finish2-start2+1));
    covimageY=temp;
end