//Standard libs
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//mex support 
#include "mex.h"
#include "matrix.h"


//should be more general
#define WINDOW_SIDE 6

#define UINT16 unsigned short

void doFindStat(UINT16 *imIn,double *updVal,mwSize *inSize,
        mwSize *outSize,mwSize *winSize){
                            

    //calculate the actual normalization   
            
    int curP=0;
    double pixelValPrim = 0; //primitive pixel value
    double pixelVal = 0; //processed pixel value
    
    double padMean=0;
  

    //fill in the meanHold table
   
        
    for (int k=0; k<inSize[1]; k++){
         for (int j=0; j<inSize[0]; j++){
            
            for (int i=0; i<inSize[2]; i++){
             
                
                  
                //find space averaged time value
                pixelVal = 0;
                for (int a=-winSize[0]/2; a<winSize[0]/2; a++){
                    for (int b=-winSize[1]/2; b<winSize[1]/2; b++){
                        // point corresponding to pixel (a,b) in window
                        // on image imIn around (j,k) at time i
                        
                        curP=(j+a)+((k+b)*inSize[0])
                                    +(i*inSize[0]*inSize[1]);
                        
                        pixelValPrim = padMean;
                        if (curP>-1 && ((j+a)+((k+b)*inSize[0]))<
                                    (inSize[0]*inSize[1]-1)) {
                                pixelValPrim=double(imIn[curP]);
                                
                          
                        }
                        pixelVal+=pixelValPrim;
                    }//for (int b=-winSize[1]/2; b<winSize[1]/2; b++)
                }//for (int a=-winSize[0]/2; a<winSize[0]/2; a++)
                
                
                curP=(j)+((k)*inSize[0])
                                    +(i*inSize[0]*inSize[1]);
              
                updVal[curP]=pixelVal/double(winSize[0]*winSize[1]);
                
                
                
            } //for (int i=0; i<inSize[2]; i++)      
        } //for (int k=0; k<inSize[1]; k++)
    } //for (int j=0; j<inSize[0]; j++)
    
}                        

//Matlab entry point
void mexFunction( int nlhs, mxArray *plhs[],
                        int nrhs, const mxArray *prhs[]){
                            
    //verify input

    if(nrhs!=1)
        mexErrMsgTxt("One input is requried by makestatimage_opt.cpp");
    if(!mxIsClass(prhs[0],"uint16"))
        mexErrMsgTxt("Input image is expected to be of UINT16 class");
    if(nlhs!=1)
        mexErrMsgTxt("One output is required");
    
    //intialize

  
    
    mwSize winSize[2];
    winSize[0]=(mwSize)(WINDOW_SIDE);
    winSize[1]=(mwSize)(WINDOW_SIDE);
   
    mwSize *inSize= (mwSize *)mxGetDimensions(prhs[0]); 
    


    double *updVal=NULL;
    updVal=(double*)mxCalloc(inSize[2]*inSize[1]*inSize[0],sizeof(double));
   
    
    UINT16 * inputIm = (UINT16*)(mxGetPr(prhs[0]));
    

    //compute what is needed

   doFindStat(inputIm,updVal,inSize,inSize,winSize);

                  
                    
       
    //handle output

    plhs[0]=mxCreateNumericArray(3,inSize,	mxDOUBLE_CLASS,mxREAL);
   // plhs[0]=mxCreateDoubleMatrix(inSize[0]*inSize[1]*inSize[2],1,mxREAL);
    
     
    double * outputPr=(double *)mxGetData(plhs[0]);
    if (outputPr==NULL){
        mexPrintf("could not allocate output");
        fflush(NULL);
    }
    
    int cpySize = inSize[0]*inSize[1]*inSize[2]*sizeof(double);
    memcpy(outputPr,updVal,cpySize);
    mxFree(updVal);
     
    
}