function neuronStatImage(stackName,basename)

%load first channels
fileName=stackName;

%filename

%disp 'lkjljlkjlkj'

if strcmpi(fileName((end-2):end),'tif'),
    imf=imfinfo(fileName);
    numFrames = length(imf);
    imch1=zeros(imf(1).Height,imf(1).Width,numFrames);
    for i = 1:numFrames,
        imch1(:,:,i) = 	uint16(imread(fileName,i));
    end
elseif strcmpi(fileName((end-2):end),'mpd'),
    d = mp2mat(fileName);
    
    temp=input('What channel should we analyze (1,2,3): ','s');
    switch temp,
        case '2' 
            imch1 = d.Ch2;
        case '3'
            imch1 = d.Ch3;
        otherwise
            imch1 = d.Ch1;
    end
    
    resizeratio=1.4/str2double(d.Header.Magnification(2:end)); 
    if resizeratio~=1,
       s=size(imch1);
       
       for j=1:s(3),
          imch1_new(:,:,j)=imresize(imch1(:,:,j),resizeratio);
       end
       imch1=imch1_new;
       clear('imch1_new');
    end
    
else
    error('Cannot load stack'); 
end

[ corrimageX corrimageY covimageX covimageY varimage] = makestatimage(imch1,5);

meanimage=makeaverageimg(imch1);
corrimage=sqrt(corrimageX.^2+corrimageY.^2);
covimage=sqrt(covimageX.^2+covimageY.^2);

meanimage=meanimage-min(meanimage(:));
meanimage=meanimage/max(meanimage(:))*65500.0;

covimage=covimage-min(covimage(:));
covimage=covimage/max(covimage(:))*65500.0;

corrimage=corrimage-min(corrimage(:));
corrimage=corrimage/max(corrimage(:))*65500.0;

varimage=varimage-min(varimage(:));
varimage=varimage/max(varimage(:))*65500.0;

imwrite(uint16(meanimage),[basename '.mean.tif'],'tif');
imwrite(uint16(varimage),[basename '.var.tif'],'tif');
imwrite(uint16(covimage),[basename '.cov.tif'],'tif');
imwrite(uint16(corrimage),[basename '.corr.tif'],'tif');