function normalizeImage(inputImage, outputImage,scale)
%Normalized the image for worms

img = imread(inputImage);

img = double(img);
img = img-min(img(:));
img = img/max(img(:));

limg = log(img+0.04);
[h w]=size(img);

smallImg = imresize(limg,1/scale);
medfiltImg = medfilt2(smallImg,[25 25]);
bigMedImg = imresize(medfiltImg,scale);

bigMedImg = bigMedImg(1:h,1:w);

normImg = limg-bigMedImg;
xx = prctile(normImg(:),[2 98]);
normImg(normImg(:)<xx(1))=xx(1);
normImg(normImg(:)>xx(2))=xx(2);

normImg = normImg-min(normImg(:));
normImg = uint8(255*normImg/max(normImg(:)));
imwrite(normImg,outputImage,'tiff');
